"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var bt = require("@babel/types");
var getDocblock_1 = require("../utils/getDocblock");
var getDoclets_1 = require("../utils/getDoclets");
var transformTagsIntoObject_1 = require("../utils/transformTagsIntoObject");
function propHandler(documentation, path) {
    var componentCommentedPath = path.parentPath;
    // in case of Vue.extend() structure
    if (bt.isCallExpression(componentCommentedPath.node)) {
        componentCommentedPath = componentCommentedPath.parentPath.parentPath;
    }
    else if (bt.isDeclaration(componentCommentedPath.node)) {
        var classDeclaration = componentCommentedPath.get('declaration');
        if (bt.isClassDeclaration(classDeclaration.node)) {
            componentCommentedPath = classDeclaration;
        }
    }
    var docBlock = getDocblock_1.default(componentCommentedPath);
    // if no prop return
    if (!docBlock || !docBlock.length) {
        return;
    }
    var jsDoc = getDoclets_1.default(docBlock);
    documentation.set('description', jsDoc.description);
    documentation.set('tags', transformTagsIntoObject_1.default(jsDoc.tags || []));
}
exports.default = propHandler;
//# sourceMappingURL=componentHandler.js.map