"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var eventHandler_1 = require("../script-handlers/eventHandler");
var getDocblock_1 = require("../utils/getDocblock");
var getDoclets_1 = require("../utils/getDoclets");
// tslint:disable-next-line:no-var-requires
var recast = require("recast");
function oldEventsHanlder(documentation, path, ast) {
    recast.visit(ast.program, {
        visitComment: function (commentPath) {
            var comment = commentPath.node.leadingComments && commentPath.node.leadingComments[0];
            // only observe block comments
            if (!comment || comment.type !== 'CommentBlock') {
                return false;
            }
            var docblock = getDocblock_1.parseDocblock(comment.value);
            var jsDoc = getDoclets_1.default(docblock);
            // filter comments where a tag is @event
            var nonNullTags = jsDoc.tags ? jsDoc.tags : [];
            var eventTag = nonNullTags.filter(function (t) { return t.title === 'event'; });
            if (!eventTag.length) {
                return false;
            }
            var eventTagContent = eventTag[0].content;
            var eventName = typeof eventTagContent === 'string' ? eventTagContent : undefined;
            if (eventName) {
                var descriptor = documentation.getEventDescriptor(eventName);
                eventHandler_1.setEventDescriptor(descriptor, jsDoc);
            }
            return false;
        },
    });
}
exports.default = oldEventsHanlder;
//# sourceMappingURL=oldEventsHandler.js.map