"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var bt = require("@babel/types");
// tslint:disable-next-line:no-var-requires
var recast = require("recast");
function eventHandler(documentation, path) {
    if (bt.isObjectExpression(path.node)) {
        var renderPath = path
            .get('properties')
            .filter(function (p) { return bt.isObjectProperty(p.node) && p.node.key.name === 'render'; });
        // if no prop return
        if (!renderPath.length) {
            return;
        }
        var renderValuePath = renderPath[0].get('value');
        recast.visit(renderValuePath, {
            visitCallExpression: function (pathCall) {
                if (bt.isMemberExpression(pathCall.node.callee) &&
                    bt.isMemberExpression(pathCall.node.callee.object) &&
                    bt.isThisExpression(pathCall.node.callee.object.object) &&
                    bt.isIdentifier(pathCall.node.callee.property) &&
                    pathCall.node.callee.object.property.name === '$scopedSlots') {
                    documentation.getSlotDescriptor(pathCall.node.callee.property.name);
                    return false;
                }
                this.traverse(pathCall);
            },
            visitMemberExpression: function (pathMember) {
                if (bt.isMemberExpression(pathMember.node.object) &&
                    bt.isThisExpression(pathMember.node.object.object) &&
                    bt.isIdentifier(pathMember.node.object.property) &&
                    pathMember.node.object.property.name === '$slots' &&
                    bt.isIdentifier(pathMember.node.property)) {
                    documentation.getSlotDescriptor(pathMember.node.property.name);
                    return false;
                }
                this.traverse(pathMember);
            },
        });
    }
}
exports.default = eventHandler;
//# sourceMappingURL=slotHandler.js.map